//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

//LEGACY
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        public GomOrderFlowProValues GomOrderFlowProValues(bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return GomOrderFlowProValues(Input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, 0,imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, false,reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        public GomOrderFlowProValues GomOrderFlowProValues(Data.IDataSeries input, bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return GomOrderFlowProValues(input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, 0,imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, false,reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
	
		public GomOrderFlowProValues GomOrderFlowProValues(bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return GomOrderFlowProValues(Input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, 0,imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
		
		public GomOrderFlowProValues GomOrderFlowProValues(Data.IDataSeries input,bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return GomOrderFlowProValues(input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, 0,imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
		
	}
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {

        public Indicator.GomOrderFlowProValues GomOrderFlowProValues(bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProValues(Input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume,imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
		}

        public Indicator.GomOrderFlowProValues GomOrderFlowProValues(Data.IDataSeries input, bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProValues(input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume,imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
		
		
		
		public Indicator.GomOrderFlowProValues GomOrderFlowProValues(bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProValues(Input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        public Indicator.GomOrderFlowProValues GomOrderFlowProValues(Data.IDataSeries input, bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProValues(input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
		
		
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        public Indicator.GomOrderFlowProValues GomOrderFlowProValues(bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProValues(Input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        public Indicator.GomOrderFlowProValues GomOrderFlowProValues(Data.IDataSeries input, bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomOrderFlowProValues(input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
		
		
		
		public Indicator.GomOrderFlowProValues GomOrderFlowProValues(bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProValues(Input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }


        public Indicator.GomOrderFlowProValues GomOrderFlowProValues(Data.IDataSeries input, bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomOrderFlowProValues(input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
		
    }
}

namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {


        public GomOrderFlowProLevels GomOrderFlowProLevels(Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return GomOrderFlowProLevels(Input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, 0,imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        public GomOrderFlowProLevels GomOrderFlowProLevels(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume,int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
             return GomOrderFlowProLevels(input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, 0,imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        public Indicator.GomOrderFlowProLevels GomOrderFlowProLevels(Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProLevels(Input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        public Indicator.GomOrderFlowProLevels GomOrderFlowProLevels(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProLevels(input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        public Indicator.GomOrderFlowProLevels GomOrderFlowProLevels(Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProLevels(Input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        public Indicator.GomOrderFlowProLevels GomOrderFlowProLevels(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomOrderFlowProLevels(input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
    }
}


//END LEGACY

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private GomCDPro[] cacheGomCDPro = null;
        private GomDeltaMomentumPro[] cacheGomDeltaMomentumPro = null;
        private GomDeltaVolumePro[] cacheGomDeltaVolumePro = null;
        private GomMPPro[] cacheGomMPPro = null;
        private GomMPProLevels[] cacheGomMPProLevels = null;
        private GomOrderFlowPro[] cacheGomOrderFlowPro = null;
        private GomOrderFlowCustomUpDownSignal[] cacheGomOrderFlowCustomUpDownSignal = null;
        private GomOrderFlowCustomValue[] cacheGomOrderFlowCustomValue = null;
        private GomOrderFlowProLevels[] cacheGomOrderFlowProLevels = null;
        private GomOrderFlowProValues[] cacheGomOrderFlowProValues = null;

        private static GomCDPro checkGomCDPro = new GomCDPro();
        private static GomDeltaMomentumPro checkGomDeltaMomentumPro = new GomDeltaMomentumPro();
        private static GomDeltaVolumePro checkGomDeltaVolumePro = new GomDeltaVolumePro();
        private static GomMPPro checkGomMPPro = new GomMPPro();
        private static GomMPProLevels checkGomMPProLevels = new GomMPProLevels();
        private static GomOrderFlowPro checkGomOrderFlowPro = new GomOrderFlowPro();
        private static GomOrderFlowCustomUpDownSignal checkGomOrderFlowCustomUpDownSignal = new GomOrderFlowCustomUpDownSignal();
        private static GomOrderFlowCustomValue checkGomOrderFlowCustomValue = new GomOrderFlowCustomValue();
        private static GomOrderFlowProLevels checkGomOrderFlowProLevels = new GomOrderFlowProLevels();
        private static GomOrderFlowProValues checkGomOrderFlowProValues = new GomOrderFlowProValues();

        /// <summary>
        /// Gom Cumulative Delta Pro
        /// </summary>
        /// <returns></returns>
        public GomCDPro GomCDPro(Gom.CDPro.GomCDChartType chart, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize, bool reinitSession)
        {
            return GomCDPro(Input, chart, deltaMode, maxTickSize, minTickSize, reinitSession);
        }

        /// <summary>
        /// Gom Cumulative Delta Pro
        /// </summary>
        /// <returns></returns>
        public GomCDPro GomCDPro(Data.IDataSeries input, Gom.CDPro.GomCDChartType chart, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize, bool reinitSession)
        {
            if (cacheGomCDPro != null)
                for (int idx = 0; idx < cacheGomCDPro.Length; idx++)
                    if (cacheGomCDPro[idx].Chart == chart && cacheGomCDPro[idx].DeltaMode == deltaMode && cacheGomCDPro[idx].MaxTickSize == maxTickSize && cacheGomCDPro[idx].MinTickSize == minTickSize && cacheGomCDPro[idx].reinitSession == reinitSession && cacheGomCDPro[idx].EqualsInput(input))
                        return cacheGomCDPro[idx];

            lock (checkGomCDPro)
            {
                checkGomCDPro.Chart = chart;
                chart = checkGomCDPro.Chart;
                checkGomCDPro.DeltaMode = deltaMode;
                deltaMode = checkGomCDPro.DeltaMode;
                checkGomCDPro.MaxTickSize = maxTickSize;
                maxTickSize = checkGomCDPro.MaxTickSize;
                checkGomCDPro.MinTickSize = minTickSize;
                minTickSize = checkGomCDPro.MinTickSize;
                checkGomCDPro.reinitSession = reinitSession;
                reinitSession = checkGomCDPro.reinitSession;

                if (cacheGomCDPro != null)
                    for (int idx = 0; idx < cacheGomCDPro.Length; idx++)
                        if (cacheGomCDPro[idx].Chart == chart && cacheGomCDPro[idx].DeltaMode == deltaMode && cacheGomCDPro[idx].MaxTickSize == maxTickSize && cacheGomCDPro[idx].MinTickSize == minTickSize && cacheGomCDPro[idx].reinitSession == reinitSession && cacheGomCDPro[idx].EqualsInput(input))
                            return cacheGomCDPro[idx];

                GomCDPro indicator = new GomCDPro();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Chart = chart;
                indicator.DeltaMode = deltaMode;
                indicator.MaxTickSize = maxTickSize;
                indicator.MinTickSize = minTickSize;
                indicator.reinitSession = reinitSession;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomCDPro[] tmp = new GomCDPro[cacheGomCDPro == null ? 1 : cacheGomCDPro.Length + 1];
                if (cacheGomCDPro != null)
                    cacheGomCDPro.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomCDPro = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Gom Delta Momentum Pro
        /// </summary>
        /// <returns></returns>
        public GomDeltaMomentumPro GomDeltaMomentumPro(Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            return GomDeltaMomentumPro(Input, deltaMode, maxTickSize, minTickSize);
        }

        /// <summary>
        /// Gom Delta Momentum Pro
        /// </summary>
        /// <returns></returns>
        public GomDeltaMomentumPro GomDeltaMomentumPro(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            if (cacheGomDeltaMomentumPro != null)
                for (int idx = 0; idx < cacheGomDeltaMomentumPro.Length; idx++)
                    if (cacheGomDeltaMomentumPro[idx].DeltaMode == deltaMode && cacheGomDeltaMomentumPro[idx].MaxTickSize == maxTickSize && cacheGomDeltaMomentumPro[idx].MinTickSize == minTickSize && cacheGomDeltaMomentumPro[idx].EqualsInput(input))
                        return cacheGomDeltaMomentumPro[idx];

            lock (checkGomDeltaMomentumPro)
            {
                checkGomDeltaMomentumPro.DeltaMode = deltaMode;
                deltaMode = checkGomDeltaMomentumPro.DeltaMode;
                checkGomDeltaMomentumPro.MaxTickSize = maxTickSize;
                maxTickSize = checkGomDeltaMomentumPro.MaxTickSize;
                checkGomDeltaMomentumPro.MinTickSize = minTickSize;
                minTickSize = checkGomDeltaMomentumPro.MinTickSize;

                if (cacheGomDeltaMomentumPro != null)
                    for (int idx = 0; idx < cacheGomDeltaMomentumPro.Length; idx++)
                        if (cacheGomDeltaMomentumPro[idx].DeltaMode == deltaMode && cacheGomDeltaMomentumPro[idx].MaxTickSize == maxTickSize && cacheGomDeltaMomentumPro[idx].MinTickSize == minTickSize && cacheGomDeltaMomentumPro[idx].EqualsInput(input))
                            return cacheGomDeltaMomentumPro[idx];

                GomDeltaMomentumPro indicator = new GomDeltaMomentumPro();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.DeltaMode = deltaMode;
                indicator.MaxTickSize = maxTickSize;
                indicator.MinTickSize = minTickSize;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomDeltaMomentumPro[] tmp = new GomDeltaMomentumPro[cacheGomDeltaMomentumPro == null ? 1 : cacheGomDeltaMomentumPro.Length + 1];
                if (cacheGomDeltaMomentumPro != null)
                    cacheGomDeltaMomentumPro.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomDeltaMomentumPro = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Gom Delta Volume Pro
        /// </summary>
        /// <returns></returns>
        public GomDeltaVolumePro GomDeltaVolumePro(Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            return GomDeltaVolumePro(Input, deltaMode, maxTickSize, minTickSize);
        }

        /// <summary>
        /// Gom Delta Volume Pro
        /// </summary>
        /// <returns></returns>
        public GomDeltaVolumePro GomDeltaVolumePro(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            if (cacheGomDeltaVolumePro != null)
                for (int idx = 0; idx < cacheGomDeltaVolumePro.Length; idx++)
                    if (cacheGomDeltaVolumePro[idx].DeltaMode == deltaMode && cacheGomDeltaVolumePro[idx].MaxTickSize == maxTickSize && cacheGomDeltaVolumePro[idx].MinTickSize == minTickSize && cacheGomDeltaVolumePro[idx].EqualsInput(input))
                        return cacheGomDeltaVolumePro[idx];

            lock (checkGomDeltaVolumePro)
            {
                checkGomDeltaVolumePro.DeltaMode = deltaMode;
                deltaMode = checkGomDeltaVolumePro.DeltaMode;
                checkGomDeltaVolumePro.MaxTickSize = maxTickSize;
                maxTickSize = checkGomDeltaVolumePro.MaxTickSize;
                checkGomDeltaVolumePro.MinTickSize = minTickSize;
                minTickSize = checkGomDeltaVolumePro.MinTickSize;

                if (cacheGomDeltaVolumePro != null)
                    for (int idx = 0; idx < cacheGomDeltaVolumePro.Length; idx++)
                        if (cacheGomDeltaVolumePro[idx].DeltaMode == deltaMode && cacheGomDeltaVolumePro[idx].MaxTickSize == maxTickSize && cacheGomDeltaVolumePro[idx].MinTickSize == minTickSize && cacheGomDeltaVolumePro[idx].EqualsInput(input))
                            return cacheGomDeltaVolumePro[idx];

                GomDeltaVolumePro indicator = new GomDeltaVolumePro();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.DeltaMode = deltaMode;
                indicator.MaxTickSize = maxTickSize;
                indicator.MinTickSize = minTickSize;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomDeltaVolumePro[] tmp = new GomDeltaVolumePro[cacheGomDeltaVolumePro == null ? 1 : cacheGomDeltaVolumePro.Length + 1];
                if (cacheGomDeltaVolumePro != null)
                    cacheGomDeltaVolumePro.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomDeltaVolumePro = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GomMPPro
        /// </summary>
        /// <returns></returns>
        public GomMPPro GomMPPro()
        {
            return GomMPPro(Input);
        }

        /// <summary>
        /// GomMPPro
        /// </summary>
        /// <returns></returns>
        public GomMPPro GomMPPro(Data.IDataSeries input)
        {
            if (cacheGomMPPro != null)
                for (int idx = 0; idx < cacheGomMPPro.Length; idx++)
                    if (cacheGomMPPro[idx].EqualsInput(input))
                        return cacheGomMPPro[idx];

            lock (checkGomMPPro)
            {
                if (cacheGomMPPro != null)
                    for (int idx = 0; idx < cacheGomMPPro.Length; idx++)
                        if (cacheGomMPPro[idx].EqualsInput(input))
                            return cacheGomMPPro[idx];

                GomMPPro indicator = new GomMPPro();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomMPPro[] tmp = new GomMPPro[cacheGomMPPro == null ? 1 : cacheGomMPPro.Length + 1];
                if (cacheGomMPPro != null)
                    cacheGomMPPro.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomMPPro = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GomMPProLevels
        /// </summary>
        /// <returns></returns>
        public GomMPProLevels GomMPProLevels(Gom.MP.DataSourceType dataSource, bool limitToOneDay, int nbSmooth, int nValue, Gom.MP.Periodicity period, string sessionEndTimeSerialize, string sessionStartTimeSerialize, Gom.Lib.GomTZ sessionTimeZone, int ticksPerVolumeBar, bool useCustomSession, double vAPercent, int vNSize, Gom.MP.ProfileData vT)
        {
            return GomMPProLevels(Input, dataSource, limitToOneDay, nbSmooth, nValue, period, sessionEndTimeSerialize, sessionStartTimeSerialize, sessionTimeZone, ticksPerVolumeBar, useCustomSession, vAPercent, vNSize, vT);
        }

        /// <summary>
        /// GomMPProLevels
        /// </summary>
        /// <returns></returns>
        public GomMPProLevels GomMPProLevels(Data.IDataSeries input, Gom.MP.DataSourceType dataSource, bool limitToOneDay, int nbSmooth, int nValue, Gom.MP.Periodicity period, string sessionEndTimeSerialize, string sessionStartTimeSerialize, Gom.Lib.GomTZ sessionTimeZone, int ticksPerVolumeBar, bool useCustomSession, double vAPercent, int vNSize, Gom.MP.ProfileData vT)
        {
            if (cacheGomMPProLevels != null)
                for (int idx = 0; idx < cacheGomMPProLevels.Length; idx++)
                    if (cacheGomMPProLevels[idx].DataSource == dataSource && cacheGomMPProLevels[idx].LimitToOneDay == limitToOneDay && cacheGomMPProLevels[idx].NbSmooth == nbSmooth && cacheGomMPProLevels[idx].NValue == nValue && cacheGomMPProLevels[idx].Period == period && cacheGomMPProLevels[idx].SessionEndTimeSerialize == sessionEndTimeSerialize && cacheGomMPProLevels[idx].SessionStartTimeSerialize == sessionStartTimeSerialize && cacheGomMPProLevels[idx].SessionTimeZone == sessionTimeZone && cacheGomMPProLevels[idx].TicksPerVolumeBar == ticksPerVolumeBar && cacheGomMPProLevels[idx].UseCustomSession == useCustomSession && Math.Abs(cacheGomMPProLevels[idx].VAPercent - vAPercent) <= double.Epsilon && cacheGomMPProLevels[idx].VNSize == vNSize && cacheGomMPProLevels[idx].VT == vT && cacheGomMPProLevels[idx].EqualsInput(input))
                        return cacheGomMPProLevels[idx];

            lock (checkGomMPProLevels)
            {
                checkGomMPProLevels.DataSource = dataSource;
                dataSource = checkGomMPProLevels.DataSource;
                checkGomMPProLevels.LimitToOneDay = limitToOneDay;
                limitToOneDay = checkGomMPProLevels.LimitToOneDay;
                checkGomMPProLevels.NbSmooth = nbSmooth;
                nbSmooth = checkGomMPProLevels.NbSmooth;
                checkGomMPProLevels.NValue = nValue;
                nValue = checkGomMPProLevels.NValue;
                checkGomMPProLevels.Period = period;
                period = checkGomMPProLevels.Period;
                checkGomMPProLevels.SessionEndTimeSerialize = sessionEndTimeSerialize;
                sessionEndTimeSerialize = checkGomMPProLevels.SessionEndTimeSerialize;
                checkGomMPProLevels.SessionStartTimeSerialize = sessionStartTimeSerialize;
                sessionStartTimeSerialize = checkGomMPProLevels.SessionStartTimeSerialize;
                checkGomMPProLevels.SessionTimeZone = sessionTimeZone;
                sessionTimeZone = checkGomMPProLevels.SessionTimeZone;
                checkGomMPProLevels.TicksPerVolumeBar = ticksPerVolumeBar;
                ticksPerVolumeBar = checkGomMPProLevels.TicksPerVolumeBar;
                checkGomMPProLevels.UseCustomSession = useCustomSession;
                useCustomSession = checkGomMPProLevels.UseCustomSession;
                checkGomMPProLevels.VAPercent = vAPercent;
                vAPercent = checkGomMPProLevels.VAPercent;
                checkGomMPProLevels.VNSize = vNSize;
                vNSize = checkGomMPProLevels.VNSize;
                checkGomMPProLevels.VT = vT;
                vT = checkGomMPProLevels.VT;

                if (cacheGomMPProLevels != null)
                    for (int idx = 0; idx < cacheGomMPProLevels.Length; idx++)
                        if (cacheGomMPProLevels[idx].DataSource == dataSource && cacheGomMPProLevels[idx].LimitToOneDay == limitToOneDay && cacheGomMPProLevels[idx].NbSmooth == nbSmooth && cacheGomMPProLevels[idx].NValue == nValue && cacheGomMPProLevels[idx].Period == period && cacheGomMPProLevels[idx].SessionEndTimeSerialize == sessionEndTimeSerialize && cacheGomMPProLevels[idx].SessionStartTimeSerialize == sessionStartTimeSerialize && cacheGomMPProLevels[idx].SessionTimeZone == sessionTimeZone && cacheGomMPProLevels[idx].TicksPerVolumeBar == ticksPerVolumeBar && cacheGomMPProLevels[idx].UseCustomSession == useCustomSession && Math.Abs(cacheGomMPProLevels[idx].VAPercent - vAPercent) <= double.Epsilon && cacheGomMPProLevels[idx].VNSize == vNSize && cacheGomMPProLevels[idx].VT == vT && cacheGomMPProLevels[idx].EqualsInput(input))
                            return cacheGomMPProLevels[idx];

                GomMPProLevels indicator = new GomMPProLevels();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.DataSource = dataSource;
                indicator.LimitToOneDay = limitToOneDay;
                indicator.NbSmooth = nbSmooth;
                indicator.NValue = nValue;
                indicator.Period = period;
                indicator.SessionEndTimeSerialize = sessionEndTimeSerialize;
                indicator.SessionStartTimeSerialize = sessionStartTimeSerialize;
                indicator.SessionTimeZone = sessionTimeZone;
                indicator.TicksPerVolumeBar = ticksPerVolumeBar;
                indicator.UseCustomSession = useCustomSession;
                indicator.VAPercent = vAPercent;
                indicator.VNSize = vNSize;
                indicator.VT = vT;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomMPProLevels[] tmp = new GomMPProLevels[cacheGomMPProLevels == null ? 1 : cacheGomMPProLevels.Length + 1];
                if (cacheGomMPProLevels != null)
                    cacheGomMPProLevels.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomMPProLevels = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GomOrderFlow
        /// </summary>
        /// <returns></returns>
        public GomOrderFlowPro GomOrderFlowPro()
        {
            return GomOrderFlowPro(Input);
        }

        /// <summary>
        /// GomOrderFlow
        /// </summary>
        /// <returns></returns>
        public GomOrderFlowPro GomOrderFlowPro(Data.IDataSeries input)
        {
            if (cacheGomOrderFlowPro != null)
                for (int idx = 0; idx < cacheGomOrderFlowPro.Length; idx++)
                    if (cacheGomOrderFlowPro[idx].EqualsInput(input))
                        return cacheGomOrderFlowPro[idx];

            lock (checkGomOrderFlowPro)
            {
                if (cacheGomOrderFlowPro != null)
                    for (int idx = 0; idx < cacheGomOrderFlowPro.Length; idx++)
                        if (cacheGomOrderFlowPro[idx].EqualsInput(input))
                            return cacheGomOrderFlowPro[idx];

                GomOrderFlowPro indicator = new GomOrderFlowPro();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomOrderFlowPro[] tmp = new GomOrderFlowPro[cacheGomOrderFlowPro == null ? 1 : cacheGomOrderFlowPro.Length + 1];
                if (cacheGomOrderFlowPro != null)
                    cacheGomOrderFlowPro.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomOrderFlowPro = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GomOrderFlowCustomUpDownSignal
        /// </summary>
        /// <returns></returns>
        public GomOrderFlowCustomUpDownSignal GomOrderFlowCustomUpDownSignal()
        {
            return GomOrderFlowCustomUpDownSignal(Input);
        }

        /// <summary>
        /// GomOrderFlowCustomUpDownSignal
        /// </summary>
        /// <returns></returns>
        public GomOrderFlowCustomUpDownSignal GomOrderFlowCustomUpDownSignal(Data.IDataSeries input)
        {
            if (cacheGomOrderFlowCustomUpDownSignal != null)
                for (int idx = 0; idx < cacheGomOrderFlowCustomUpDownSignal.Length; idx++)
                    if (cacheGomOrderFlowCustomUpDownSignal[idx].EqualsInput(input))
                        return cacheGomOrderFlowCustomUpDownSignal[idx];

            lock (checkGomOrderFlowCustomUpDownSignal)
            {
                if (cacheGomOrderFlowCustomUpDownSignal != null)
                    for (int idx = 0; idx < cacheGomOrderFlowCustomUpDownSignal.Length; idx++)
                        if (cacheGomOrderFlowCustomUpDownSignal[idx].EqualsInput(input))
                            return cacheGomOrderFlowCustomUpDownSignal[idx];

                GomOrderFlowCustomUpDownSignal indicator = new GomOrderFlowCustomUpDownSignal();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomOrderFlowCustomUpDownSignal[] tmp = new GomOrderFlowCustomUpDownSignal[cacheGomOrderFlowCustomUpDownSignal == null ? 1 : cacheGomOrderFlowCustomUpDownSignal.Length + 1];
                if (cacheGomOrderFlowCustomUpDownSignal != null)
                    cacheGomOrderFlowCustomUpDownSignal.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomOrderFlowCustomUpDownSignal = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GomOrderFlowCustomValue
        /// </summary>
        /// <returns></returns>
        public GomOrderFlowCustomValue GomOrderFlowCustomValue()
        {
            return GomOrderFlowCustomValue(Input);
        }

        /// <summary>
        /// GomOrderFlowCustomValue
        /// </summary>
        /// <returns></returns>
        public GomOrderFlowCustomValue GomOrderFlowCustomValue(Data.IDataSeries input)
        {
            if (cacheGomOrderFlowCustomValue != null)
                for (int idx = 0; idx < cacheGomOrderFlowCustomValue.Length; idx++)
                    if (cacheGomOrderFlowCustomValue[idx].EqualsInput(input))
                        return cacheGomOrderFlowCustomValue[idx];

            lock (checkGomOrderFlowCustomValue)
            {
                if (cacheGomOrderFlowCustomValue != null)
                    for (int idx = 0; idx < cacheGomOrderFlowCustomValue.Length; idx++)
                        if (cacheGomOrderFlowCustomValue[idx].EqualsInput(input))
                            return cacheGomOrderFlowCustomValue[idx];

                GomOrderFlowCustomValue indicator = new GomOrderFlowCustomValue();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomOrderFlowCustomValue[] tmp = new GomOrderFlowCustomValue[cacheGomOrderFlowCustomValue == null ? 1 : cacheGomOrderFlowCustomValue.Length + 1];
                if (cacheGomOrderFlowCustomValue != null)
                    cacheGomOrderFlowCustomValue.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomOrderFlowCustomValue = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// OrderFlowProLevels
        /// </summary>
        /// <returns></returns>
        public GomOrderFlowProLevels GomOrderFlowProLevels(Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return GomOrderFlowProLevels(Input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, imbalanceMinLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        /// <summary>
        /// OrderFlowProLevels
        /// </summary>
        /// <returns></returns>
        public GomOrderFlowProLevels GomOrderFlowProLevels(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            if (cacheGomOrderFlowProLevels != null)
                for (int idx = 0; idx < cacheGomOrderFlowProLevels.Length; idx++)
                    if (cacheGomOrderFlowProLevels[idx].DeltaMode == deltaMode && cacheGomOrderFlowProLevels[idx].ImbalanceCriterion1Comparison == imbalanceCriterion1Comparison && cacheGomOrderFlowProLevels[idx].ImbalanceCriterion1Direction == imbalanceCriterion1Direction && Math.Abs(cacheGomOrderFlowProLevels[idx].ImbalanceCriterion1Value - imbalanceCriterion1Value) <= double.Epsilon && cacheGomOrderFlowProLevels[idx].ImbalanceCriterion2Comparison == imbalanceCriterion2Comparison && cacheGomOrderFlowProLevels[idx].ImbalanceCriterion2Direction == imbalanceCriterion2Direction && Math.Abs(cacheGomOrderFlowProLevels[idx].ImbalanceCriterion2Value - imbalanceCriterion2Value) <= double.Epsilon && cacheGomOrderFlowProLevels[idx].ImbalanceMaxLosingSideVolume == imbalanceMaxLosingSideVolume && cacheGomOrderFlowProLevels[idx].ImbalanceMinLosingSideVolume == imbalanceMinLosingSideVolume && cacheGomOrderFlowProLevels[idx].ImbalanceMinWinningSideVolume == imbalanceMinWinningSideVolume && cacheGomOrderFlowProLevels[idx].MaxTickSize == maxTickSize && cacheGomOrderFlowProLevels[idx].MinTickSize == minTickSize && cacheGomOrderFlowProLevels[idx].ResetNakedOnSessionStart == resetNakedOnSessionStart && cacheGomOrderFlowProLevels[idx].SRCancelOnNewSession == sRCancelOnNewSession && cacheGomOrderFlowProLevels[idx].SRExit == sRExit && cacheGomOrderFlowProLevels[idx].SRHiLoThreshold == sRHiLoThreshold && cacheGomOrderFlowProLevels[idx].SRMinTotalVolume == sRMinTotalVolume && cacheGomOrderFlowProLevels[idx].SRNbLevels == sRNbLevels && cacheGomOrderFlowProLevels[idx].TicksPerPriceLevel == ticksPerPriceLevel && cacheGomOrderFlowProLevels[idx].EqualsInput(input))
                        return cacheGomOrderFlowProLevels[idx];

            lock (checkGomOrderFlowProLevels)
            {
                checkGomOrderFlowProLevels.DeltaMode = deltaMode;
                deltaMode = checkGomOrderFlowProLevels.DeltaMode;
                checkGomOrderFlowProLevels.ImbalanceCriterion1Comparison = imbalanceCriterion1Comparison;
                imbalanceCriterion1Comparison = checkGomOrderFlowProLevels.ImbalanceCriterion1Comparison;
                checkGomOrderFlowProLevels.ImbalanceCriterion1Direction = imbalanceCriterion1Direction;
                imbalanceCriterion1Direction = checkGomOrderFlowProLevels.ImbalanceCriterion1Direction;
                checkGomOrderFlowProLevels.ImbalanceCriterion1Value = imbalanceCriterion1Value;
                imbalanceCriterion1Value = checkGomOrderFlowProLevels.ImbalanceCriterion1Value;
                checkGomOrderFlowProLevels.ImbalanceCriterion2Comparison = imbalanceCriterion2Comparison;
                imbalanceCriterion2Comparison = checkGomOrderFlowProLevels.ImbalanceCriterion2Comparison;
                checkGomOrderFlowProLevels.ImbalanceCriterion2Direction = imbalanceCriterion2Direction;
                imbalanceCriterion2Direction = checkGomOrderFlowProLevels.ImbalanceCriterion2Direction;
                checkGomOrderFlowProLevels.ImbalanceCriterion2Value = imbalanceCriterion2Value;
                imbalanceCriterion2Value = checkGomOrderFlowProLevels.ImbalanceCriterion2Value;
                checkGomOrderFlowProLevels.ImbalanceMaxLosingSideVolume = imbalanceMaxLosingSideVolume;
                imbalanceMaxLosingSideVolume = checkGomOrderFlowProLevels.ImbalanceMaxLosingSideVolume;
                checkGomOrderFlowProLevels.ImbalanceMinLosingSideVolume = imbalanceMinLosingSideVolume;
                imbalanceMinLosingSideVolume = checkGomOrderFlowProLevels.ImbalanceMinLosingSideVolume;
                checkGomOrderFlowProLevels.ImbalanceMinWinningSideVolume = imbalanceMinWinningSideVolume;
                imbalanceMinWinningSideVolume = checkGomOrderFlowProLevels.ImbalanceMinWinningSideVolume;
                checkGomOrderFlowProLevels.MaxTickSize = maxTickSize;
                maxTickSize = checkGomOrderFlowProLevels.MaxTickSize;
                checkGomOrderFlowProLevels.MinTickSize = minTickSize;
                minTickSize = checkGomOrderFlowProLevels.MinTickSize;
                checkGomOrderFlowProLevels.ResetNakedOnSessionStart = resetNakedOnSessionStart;
                resetNakedOnSessionStart = checkGomOrderFlowProLevels.ResetNakedOnSessionStart;
                checkGomOrderFlowProLevels.SRCancelOnNewSession = sRCancelOnNewSession;
                sRCancelOnNewSession = checkGomOrderFlowProLevels.SRCancelOnNewSession;
                checkGomOrderFlowProLevels.SRExit = sRExit;
                sRExit = checkGomOrderFlowProLevels.SRExit;
                checkGomOrderFlowProLevels.SRHiLoThreshold = sRHiLoThreshold;
                sRHiLoThreshold = checkGomOrderFlowProLevels.SRHiLoThreshold;
                checkGomOrderFlowProLevels.SRMinTotalVolume = sRMinTotalVolume;
                sRMinTotalVolume = checkGomOrderFlowProLevels.SRMinTotalVolume;
                checkGomOrderFlowProLevels.SRNbLevels = sRNbLevels;
                sRNbLevels = checkGomOrderFlowProLevels.SRNbLevels;
                checkGomOrderFlowProLevels.TicksPerPriceLevel = ticksPerPriceLevel;
                ticksPerPriceLevel = checkGomOrderFlowProLevels.TicksPerPriceLevel;

                if (cacheGomOrderFlowProLevels != null)
                    for (int idx = 0; idx < cacheGomOrderFlowProLevels.Length; idx++)
                        if (cacheGomOrderFlowProLevels[idx].DeltaMode == deltaMode && cacheGomOrderFlowProLevels[idx].ImbalanceCriterion1Comparison == imbalanceCriterion1Comparison && cacheGomOrderFlowProLevels[idx].ImbalanceCriterion1Direction == imbalanceCriterion1Direction && Math.Abs(cacheGomOrderFlowProLevels[idx].ImbalanceCriterion1Value - imbalanceCriterion1Value) <= double.Epsilon && cacheGomOrderFlowProLevels[idx].ImbalanceCriterion2Comparison == imbalanceCriterion2Comparison && cacheGomOrderFlowProLevels[idx].ImbalanceCriterion2Direction == imbalanceCriterion2Direction && Math.Abs(cacheGomOrderFlowProLevels[idx].ImbalanceCriterion2Value - imbalanceCriterion2Value) <= double.Epsilon && cacheGomOrderFlowProLevels[idx].ImbalanceMaxLosingSideVolume == imbalanceMaxLosingSideVolume && cacheGomOrderFlowProLevels[idx].ImbalanceMinLosingSideVolume == imbalanceMinLosingSideVolume && cacheGomOrderFlowProLevels[idx].ImbalanceMinWinningSideVolume == imbalanceMinWinningSideVolume && cacheGomOrderFlowProLevels[idx].MaxTickSize == maxTickSize && cacheGomOrderFlowProLevels[idx].MinTickSize == minTickSize && cacheGomOrderFlowProLevels[idx].ResetNakedOnSessionStart == resetNakedOnSessionStart && cacheGomOrderFlowProLevels[idx].SRCancelOnNewSession == sRCancelOnNewSession && cacheGomOrderFlowProLevels[idx].SRExit == sRExit && cacheGomOrderFlowProLevels[idx].SRHiLoThreshold == sRHiLoThreshold && cacheGomOrderFlowProLevels[idx].SRMinTotalVolume == sRMinTotalVolume && cacheGomOrderFlowProLevels[idx].SRNbLevels == sRNbLevels && cacheGomOrderFlowProLevels[idx].TicksPerPriceLevel == ticksPerPriceLevel && cacheGomOrderFlowProLevels[idx].EqualsInput(input))
                            return cacheGomOrderFlowProLevels[idx];

                GomOrderFlowProLevels indicator = new GomOrderFlowProLevels();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.DeltaMode = deltaMode;
                indicator.ImbalanceCriterion1Comparison = imbalanceCriterion1Comparison;
                indicator.ImbalanceCriterion1Direction = imbalanceCriterion1Direction;
                indicator.ImbalanceCriterion1Value = imbalanceCriterion1Value;
                indicator.ImbalanceCriterion2Comparison = imbalanceCriterion2Comparison;
                indicator.ImbalanceCriterion2Direction = imbalanceCriterion2Direction;
                indicator.ImbalanceCriterion2Value = imbalanceCriterion2Value;
                indicator.ImbalanceMaxLosingSideVolume = imbalanceMaxLosingSideVolume;
                indicator.ImbalanceMinLosingSideVolume = imbalanceMinLosingSideVolume;
                indicator.ImbalanceMinWinningSideVolume = imbalanceMinWinningSideVolume;
                indicator.MaxTickSize = maxTickSize;
                indicator.MinTickSize = minTickSize;
                indicator.ResetNakedOnSessionStart = resetNakedOnSessionStart;
                indicator.SRCancelOnNewSession = sRCancelOnNewSession;
                indicator.SRExit = sRExit;
                indicator.SRHiLoThreshold = sRHiLoThreshold;
                indicator.SRMinTotalVolume = sRMinTotalVolume;
                indicator.SRNbLevels = sRNbLevels;
                indicator.TicksPerPriceLevel = ticksPerPriceLevel;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomOrderFlowProLevels[] tmp = new GomOrderFlowProLevels[cacheGomOrderFlowProLevels == null ? 1 : cacheGomOrderFlowProLevels.Length + 1];
                if (cacheGomOrderFlowProLevels != null)
                    cacheGomOrderFlowProLevels.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomOrderFlowProLevels = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// GomOrderFlowValues
        /// </summary>
        /// <returns></returns>
        public GomOrderFlowProValues GomOrderFlowProValues(bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return GomOrderFlowProValues(Input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        /// <summary>
        /// GomOrderFlowValues
        /// </summary>
        /// <returns></returns>
        public GomOrderFlowProValues GomOrderFlowProValues(Data.IDataSeries input, bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            if (cacheGomOrderFlowProValues != null)
                for (int idx = 0; idx < cacheGomOrderFlowProValues.Length; idx++)
                    if (cacheGomOrderFlowProValues[idx].DecliningTotVolSmallerThanOppositeSideTotVol == decliningTotVolSmallerThanOppositeSideTotVol && cacheGomOrderFlowProValues[idx].DeltaMode == deltaMode && cacheGomOrderFlowProValues[idx].ImbalanceCriterion1Comparison == imbalanceCriterion1Comparison && cacheGomOrderFlowProValues[idx].ImbalanceCriterion1Direction == imbalanceCriterion1Direction && Math.Abs(cacheGomOrderFlowProValues[idx].ImbalanceCriterion1Value - imbalanceCriterion1Value) <= double.Epsilon && cacheGomOrderFlowProValues[idx].ImbalanceCriterion2Comparison == imbalanceCriterion2Comparison && cacheGomOrderFlowProValues[idx].ImbalanceCriterion2Direction == imbalanceCriterion2Direction && Math.Abs(cacheGomOrderFlowProValues[idx].ImbalanceCriterion2Value - imbalanceCriterion2Value) <= double.Epsilon && cacheGomOrderFlowProValues[idx].ImbalanceInDecliningZoneAuthorized == imbalanceInDecliningZoneAuthorized && cacheGomOrderFlowProValues[idx].ImbalanceMaxLosingSideVolume == imbalanceMaxLosingSideVolume && cacheGomOrderFlowProValues[idx].ImbalanceMinLosingSideVolume == imbalanceMinLosingSideVolume && cacheGomOrderFlowProValues[idx].ImbalanceMinWinningSideVolume == imbalanceMinWinningSideVolume && cacheGomOrderFlowProValues[idx].MaxTickSize == maxTickSize && cacheGomOrderFlowProValues[idx].MinNumOfDecliningLevels == minNumOfDecliningLevels && cacheGomOrderFlowProValues[idx].MinSizeOfCounterSideImbalance == minSizeOfCounterSideImbalance && cacheGomOrderFlowProValues[idx].MinTickSize == minTickSize && cacheGomOrderFlowProValues[idx].ReinitSession == reinitSession && cacheGomOrderFlowProValues[idx].ReversalPocPosition == reversalPocPosition && cacheGomOrderFlowProValues[idx].SRMinTotalVolume == sRMinTotalVolume && cacheGomOrderFlowProValues[idx].SRNbLevels == sRNbLevels && cacheGomOrderFlowProValues[idx].TicksPerPriceLevel == ticksPerPriceLevel && cacheGomOrderFlowProValues[idx].EqualsInput(input))
                        return cacheGomOrderFlowProValues[idx];

            lock (checkGomOrderFlowProValues)
            {
                checkGomOrderFlowProValues.DecliningTotVolSmallerThanOppositeSideTotVol = decliningTotVolSmallerThanOppositeSideTotVol;
                decliningTotVolSmallerThanOppositeSideTotVol = checkGomOrderFlowProValues.DecliningTotVolSmallerThanOppositeSideTotVol;
                checkGomOrderFlowProValues.DeltaMode = deltaMode;
                deltaMode = checkGomOrderFlowProValues.DeltaMode;
                checkGomOrderFlowProValues.ImbalanceCriterion1Comparison = imbalanceCriterion1Comparison;
                imbalanceCriterion1Comparison = checkGomOrderFlowProValues.ImbalanceCriterion1Comparison;
                checkGomOrderFlowProValues.ImbalanceCriterion1Direction = imbalanceCriterion1Direction;
                imbalanceCriterion1Direction = checkGomOrderFlowProValues.ImbalanceCriterion1Direction;
                checkGomOrderFlowProValues.ImbalanceCriterion1Value = imbalanceCriterion1Value;
                imbalanceCriterion1Value = checkGomOrderFlowProValues.ImbalanceCriterion1Value;
                checkGomOrderFlowProValues.ImbalanceCriterion2Comparison = imbalanceCriterion2Comparison;
                imbalanceCriterion2Comparison = checkGomOrderFlowProValues.ImbalanceCriterion2Comparison;
                checkGomOrderFlowProValues.ImbalanceCriterion2Direction = imbalanceCriterion2Direction;
                imbalanceCriterion2Direction = checkGomOrderFlowProValues.ImbalanceCriterion2Direction;
                checkGomOrderFlowProValues.ImbalanceCriterion2Value = imbalanceCriterion2Value;
                imbalanceCriterion2Value = checkGomOrderFlowProValues.ImbalanceCriterion2Value;
                checkGomOrderFlowProValues.ImbalanceInDecliningZoneAuthorized = imbalanceInDecliningZoneAuthorized;
                imbalanceInDecliningZoneAuthorized = checkGomOrderFlowProValues.ImbalanceInDecliningZoneAuthorized;
                checkGomOrderFlowProValues.ImbalanceMaxLosingSideVolume = imbalanceMaxLosingSideVolume;
                imbalanceMaxLosingSideVolume = checkGomOrderFlowProValues.ImbalanceMaxLosingSideVolume;
                checkGomOrderFlowProValues.ImbalanceMinLosingSideVolume = imbalanceMinLosingSideVolume;
                imbalanceMinLosingSideVolume = checkGomOrderFlowProValues.ImbalanceMinLosingSideVolume;
                checkGomOrderFlowProValues.ImbalanceMinWinningSideVolume = imbalanceMinWinningSideVolume;
                imbalanceMinWinningSideVolume = checkGomOrderFlowProValues.ImbalanceMinWinningSideVolume;
                checkGomOrderFlowProValues.MaxTickSize = maxTickSize;
                maxTickSize = checkGomOrderFlowProValues.MaxTickSize;
                checkGomOrderFlowProValues.MinNumOfDecliningLevels = minNumOfDecliningLevels;
                minNumOfDecliningLevels = checkGomOrderFlowProValues.MinNumOfDecliningLevels;
                checkGomOrderFlowProValues.MinSizeOfCounterSideImbalance = minSizeOfCounterSideImbalance;
                minSizeOfCounterSideImbalance = checkGomOrderFlowProValues.MinSizeOfCounterSideImbalance;
                checkGomOrderFlowProValues.MinTickSize = minTickSize;
                minTickSize = checkGomOrderFlowProValues.MinTickSize;
                checkGomOrderFlowProValues.ReinitSession = reinitSession;
                reinitSession = checkGomOrderFlowProValues.ReinitSession;
                checkGomOrderFlowProValues.ReversalPocPosition = reversalPocPosition;
                reversalPocPosition = checkGomOrderFlowProValues.ReversalPocPosition;
                checkGomOrderFlowProValues.SRMinTotalVolume = sRMinTotalVolume;
                sRMinTotalVolume = checkGomOrderFlowProValues.SRMinTotalVolume;
                checkGomOrderFlowProValues.SRNbLevels = sRNbLevels;
                sRNbLevels = checkGomOrderFlowProValues.SRNbLevels;
                checkGomOrderFlowProValues.TicksPerPriceLevel = ticksPerPriceLevel;
                ticksPerPriceLevel = checkGomOrderFlowProValues.TicksPerPriceLevel;

                if (cacheGomOrderFlowProValues != null)
                    for (int idx = 0; idx < cacheGomOrderFlowProValues.Length; idx++)
                        if (cacheGomOrderFlowProValues[idx].DecliningTotVolSmallerThanOppositeSideTotVol == decliningTotVolSmallerThanOppositeSideTotVol && cacheGomOrderFlowProValues[idx].DeltaMode == deltaMode && cacheGomOrderFlowProValues[idx].ImbalanceCriterion1Comparison == imbalanceCriterion1Comparison && cacheGomOrderFlowProValues[idx].ImbalanceCriterion1Direction == imbalanceCriterion1Direction && Math.Abs(cacheGomOrderFlowProValues[idx].ImbalanceCriterion1Value - imbalanceCriterion1Value) <= double.Epsilon && cacheGomOrderFlowProValues[idx].ImbalanceCriterion2Comparison == imbalanceCriterion2Comparison && cacheGomOrderFlowProValues[idx].ImbalanceCriterion2Direction == imbalanceCriterion2Direction && Math.Abs(cacheGomOrderFlowProValues[idx].ImbalanceCriterion2Value - imbalanceCriterion2Value) <= double.Epsilon && cacheGomOrderFlowProValues[idx].ImbalanceInDecliningZoneAuthorized == imbalanceInDecliningZoneAuthorized && cacheGomOrderFlowProValues[idx].ImbalanceMaxLosingSideVolume == imbalanceMaxLosingSideVolume && cacheGomOrderFlowProValues[idx].ImbalanceMinLosingSideVolume == imbalanceMinLosingSideVolume && cacheGomOrderFlowProValues[idx].ImbalanceMinWinningSideVolume == imbalanceMinWinningSideVolume && cacheGomOrderFlowProValues[idx].MaxTickSize == maxTickSize && cacheGomOrderFlowProValues[idx].MinNumOfDecliningLevels == minNumOfDecliningLevels && cacheGomOrderFlowProValues[idx].MinSizeOfCounterSideImbalance == minSizeOfCounterSideImbalance && cacheGomOrderFlowProValues[idx].MinTickSize == minTickSize && cacheGomOrderFlowProValues[idx].ReinitSession == reinitSession && cacheGomOrderFlowProValues[idx].ReversalPocPosition == reversalPocPosition && cacheGomOrderFlowProValues[idx].SRMinTotalVolume == sRMinTotalVolume && cacheGomOrderFlowProValues[idx].SRNbLevels == sRNbLevels && cacheGomOrderFlowProValues[idx].TicksPerPriceLevel == ticksPerPriceLevel && cacheGomOrderFlowProValues[idx].EqualsInput(input))
                            return cacheGomOrderFlowProValues[idx];

                GomOrderFlowProValues indicator = new GomOrderFlowProValues();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.DecliningTotVolSmallerThanOppositeSideTotVol = decliningTotVolSmallerThanOppositeSideTotVol;
                indicator.DeltaMode = deltaMode;
                indicator.ImbalanceCriterion1Comparison = imbalanceCriterion1Comparison;
                indicator.ImbalanceCriterion1Direction = imbalanceCriterion1Direction;
                indicator.ImbalanceCriterion1Value = imbalanceCriterion1Value;
                indicator.ImbalanceCriterion2Comparison = imbalanceCriterion2Comparison;
                indicator.ImbalanceCriterion2Direction = imbalanceCriterion2Direction;
                indicator.ImbalanceCriterion2Value = imbalanceCriterion2Value;
                indicator.ImbalanceInDecliningZoneAuthorized = imbalanceInDecliningZoneAuthorized;
                indicator.ImbalanceMaxLosingSideVolume = imbalanceMaxLosingSideVolume;
                indicator.ImbalanceMinLosingSideVolume = imbalanceMinLosingSideVolume;
                indicator.ImbalanceMinWinningSideVolume = imbalanceMinWinningSideVolume;
                indicator.MaxTickSize = maxTickSize;
                indicator.MinNumOfDecliningLevels = minNumOfDecliningLevels;
                indicator.MinSizeOfCounterSideImbalance = minSizeOfCounterSideImbalance;
                indicator.MinTickSize = minTickSize;
                indicator.ReinitSession = reinitSession;
                indicator.ReversalPocPosition = reversalPocPosition;
                indicator.SRMinTotalVolume = sRMinTotalVolume;
                indicator.SRNbLevels = sRNbLevels;
                indicator.TicksPerPriceLevel = ticksPerPriceLevel;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomOrderFlowProValues[] tmp = new GomOrderFlowProValues[cacheGomOrderFlowProValues == null ? 1 : cacheGomOrderFlowProValues.Length + 1];
                if (cacheGomOrderFlowProValues != null)
                    cacheGomOrderFlowProValues.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomOrderFlowProValues = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Gom Cumulative Delta Pro
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomCDPro GomCDPro(Gom.CDPro.GomCDChartType chart, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize, bool reinitSession)
        {
            return _indicator.GomCDPro(Input, chart, deltaMode, maxTickSize, minTickSize, reinitSession);
        }

        /// <summary>
        /// Gom Cumulative Delta Pro
        /// </summary>
        /// <returns></returns>
        public Indicator.GomCDPro GomCDPro(Data.IDataSeries input, Gom.CDPro.GomCDChartType chart, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize, bool reinitSession)
        {
            return _indicator.GomCDPro(input, chart, deltaMode, maxTickSize, minTickSize, reinitSession);
        }

        /// <summary>
        /// Gom Delta Momentum Pro
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomDeltaMomentumPro GomDeltaMomentumPro(Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            return _indicator.GomDeltaMomentumPro(Input, deltaMode, maxTickSize, minTickSize);
        }

        /// <summary>
        /// Gom Delta Momentum Pro
        /// </summary>
        /// <returns></returns>
        public Indicator.GomDeltaMomentumPro GomDeltaMomentumPro(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            return _indicator.GomDeltaMomentumPro(input, deltaMode, maxTickSize, minTickSize);
        }

        /// <summary>
        /// Gom Delta Volume Pro
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomDeltaVolumePro GomDeltaVolumePro(Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            return _indicator.GomDeltaVolumePro(Input, deltaMode, maxTickSize, minTickSize);
        }

        /// <summary>
        /// Gom Delta Volume Pro
        /// </summary>
        /// <returns></returns>
        public Indicator.GomDeltaVolumePro GomDeltaVolumePro(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            return _indicator.GomDeltaVolumePro(input, deltaMode, maxTickSize, minTickSize);
        }

        /// <summary>
        /// GomMPPro
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomMPPro GomMPPro()
        {
            return _indicator.GomMPPro(Input);
        }

        /// <summary>
        /// GomMPPro
        /// </summary>
        /// <returns></returns>
        public Indicator.GomMPPro GomMPPro(Data.IDataSeries input)
        {
            return _indicator.GomMPPro(input);
        }

        /// <summary>
        /// GomMPProLevels
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomMPProLevels GomMPProLevels(Gom.MP.DataSourceType dataSource, bool limitToOneDay, int nbSmooth, int nValue, Gom.MP.Periodicity period, string sessionEndTimeSerialize, string sessionStartTimeSerialize, Gom.Lib.GomTZ sessionTimeZone, int ticksPerVolumeBar, bool useCustomSession, double vAPercent, int vNSize, Gom.MP.ProfileData vT)
        {
            return _indicator.GomMPProLevels(Input, dataSource, limitToOneDay, nbSmooth, nValue, period, sessionEndTimeSerialize, sessionStartTimeSerialize, sessionTimeZone, ticksPerVolumeBar, useCustomSession, vAPercent, vNSize, vT);
        }

        /// <summary>
        /// GomMPProLevels
        /// </summary>
        /// <returns></returns>
        public Indicator.GomMPProLevels GomMPProLevels(Data.IDataSeries input, Gom.MP.DataSourceType dataSource, bool limitToOneDay, int nbSmooth, int nValue, Gom.MP.Periodicity period, string sessionEndTimeSerialize, string sessionStartTimeSerialize, Gom.Lib.GomTZ sessionTimeZone, int ticksPerVolumeBar, bool useCustomSession, double vAPercent, int vNSize, Gom.MP.ProfileData vT)
        {
            return _indicator.GomMPProLevels(input, dataSource, limitToOneDay, nbSmooth, nValue, period, sessionEndTimeSerialize, sessionStartTimeSerialize, sessionTimeZone, ticksPerVolumeBar, useCustomSession, vAPercent, vNSize, vT);
        }

        /// <summary>
        /// GomOrderFlow
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomOrderFlowPro GomOrderFlowPro()
        {
            return _indicator.GomOrderFlowPro(Input);
        }

        /// <summary>
        /// GomOrderFlow
        /// </summary>
        /// <returns></returns>
        public Indicator.GomOrderFlowPro GomOrderFlowPro(Data.IDataSeries input)
        {
            return _indicator.GomOrderFlowPro(input);
        }

        /// <summary>
        /// GomOrderFlowCustomUpDownSignal
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomOrderFlowCustomUpDownSignal GomOrderFlowCustomUpDownSignal()
        {
            return _indicator.GomOrderFlowCustomUpDownSignal(Input);
        }

        /// <summary>
        /// GomOrderFlowCustomUpDownSignal
        /// </summary>
        /// <returns></returns>
        public Indicator.GomOrderFlowCustomUpDownSignal GomOrderFlowCustomUpDownSignal(Data.IDataSeries input)
        {
            return _indicator.GomOrderFlowCustomUpDownSignal(input);
        }

        /// <summary>
        /// GomOrderFlowCustomValue
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomOrderFlowCustomValue GomOrderFlowCustomValue()
        {
            return _indicator.GomOrderFlowCustomValue(Input);
        }

        /// <summary>
        /// GomOrderFlowCustomValue
        /// </summary>
        /// <returns></returns>
        public Indicator.GomOrderFlowCustomValue GomOrderFlowCustomValue(Data.IDataSeries input)
        {
            return _indicator.GomOrderFlowCustomValue(input);
        }

        /// <summary>
        /// OrderFlowProLevels
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomOrderFlowProLevels GomOrderFlowProLevels(Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProLevels(Input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, imbalanceMinLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        /// <summary>
        /// OrderFlowProLevels
        /// </summary>
        /// <returns></returns>
        public Indicator.GomOrderFlowProLevels GomOrderFlowProLevels(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProLevels(input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, imbalanceMinLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        /// <summary>
        /// GomOrderFlowValues
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomOrderFlowProValues GomOrderFlowProValues(bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProValues(Input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        /// <summary>
        /// GomOrderFlowValues
        /// </summary>
        /// <returns></returns>
        public Indicator.GomOrderFlowProValues GomOrderFlowProValues(Data.IDataSeries input, bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProValues(input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Gom Cumulative Delta Pro
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomCDPro GomCDPro(Gom.CDPro.GomCDChartType chart, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize, bool reinitSession)
        {
            return _indicator.GomCDPro(Input, chart, deltaMode, maxTickSize, minTickSize, reinitSession);
        }

        /// <summary>
        /// Gom Cumulative Delta Pro
        /// </summary>
        /// <returns></returns>
        public Indicator.GomCDPro GomCDPro(Data.IDataSeries input, Gom.CDPro.GomCDChartType chart, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize, bool reinitSession)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomCDPro(input, chart, deltaMode, maxTickSize, minTickSize, reinitSession);
        }

        /// <summary>
        /// Gom Delta Momentum Pro
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomDeltaMomentumPro GomDeltaMomentumPro(Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            return _indicator.GomDeltaMomentumPro(Input, deltaMode, maxTickSize, minTickSize);
        }

        /// <summary>
        /// Gom Delta Momentum Pro
        /// </summary>
        /// <returns></returns>
        public Indicator.GomDeltaMomentumPro GomDeltaMomentumPro(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomDeltaMomentumPro(input, deltaMode, maxTickSize, minTickSize);
        }

        /// <summary>
        /// Gom Delta Volume Pro
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomDeltaVolumePro GomDeltaVolumePro(Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            return _indicator.GomDeltaVolumePro(Input, deltaMode, maxTickSize, minTickSize);
        }

        /// <summary>
        /// Gom Delta Volume Pro
        /// </summary>
        /// <returns></returns>
        public Indicator.GomDeltaVolumePro GomDeltaVolumePro(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, int maxTickSize, int minTickSize)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomDeltaVolumePro(input, deltaMode, maxTickSize, minTickSize);
        }

        /// <summary>
        /// GomMPPro
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomMPPro GomMPPro()
        {
            return _indicator.GomMPPro(Input);
        }

        /// <summary>
        /// GomMPPro
        /// </summary>
        /// <returns></returns>
        public Indicator.GomMPPro GomMPPro(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomMPPro(input);
        }

        /// <summary>
        /// GomMPProLevels
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomMPProLevels GomMPProLevels(Gom.MP.DataSourceType dataSource, bool limitToOneDay, int nbSmooth, int nValue, Gom.MP.Periodicity period, string sessionEndTimeSerialize, string sessionStartTimeSerialize, Gom.Lib.GomTZ sessionTimeZone, int ticksPerVolumeBar, bool useCustomSession, double vAPercent, int vNSize, Gom.MP.ProfileData vT)
        {
            return _indicator.GomMPProLevels(Input, dataSource, limitToOneDay, nbSmooth, nValue, period, sessionEndTimeSerialize, sessionStartTimeSerialize, sessionTimeZone, ticksPerVolumeBar, useCustomSession, vAPercent, vNSize, vT);
        }

        /// <summary>
        /// GomMPProLevels
        /// </summary>
        /// <returns></returns>
        public Indicator.GomMPProLevels GomMPProLevels(Data.IDataSeries input, Gom.MP.DataSourceType dataSource, bool limitToOneDay, int nbSmooth, int nValue, Gom.MP.Periodicity period, string sessionEndTimeSerialize, string sessionStartTimeSerialize, Gom.Lib.GomTZ sessionTimeZone, int ticksPerVolumeBar, bool useCustomSession, double vAPercent, int vNSize, Gom.MP.ProfileData vT)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomMPProLevels(input, dataSource, limitToOneDay, nbSmooth, nValue, period, sessionEndTimeSerialize, sessionStartTimeSerialize, sessionTimeZone, ticksPerVolumeBar, useCustomSession, vAPercent, vNSize, vT);
        }

        /// <summary>
        /// GomOrderFlow
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomOrderFlowPro GomOrderFlowPro()
        {
            return _indicator.GomOrderFlowPro(Input);
        }

        /// <summary>
        /// GomOrderFlow
        /// </summary>
        /// <returns></returns>
        public Indicator.GomOrderFlowPro GomOrderFlowPro(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomOrderFlowPro(input);
        }

        /// <summary>
        /// GomOrderFlowCustomUpDownSignal
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomOrderFlowCustomUpDownSignal GomOrderFlowCustomUpDownSignal()
        {
            return _indicator.GomOrderFlowCustomUpDownSignal(Input);
        }

        /// <summary>
        /// GomOrderFlowCustomUpDownSignal
        /// </summary>
        /// <returns></returns>
        public Indicator.GomOrderFlowCustomUpDownSignal GomOrderFlowCustomUpDownSignal(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomOrderFlowCustomUpDownSignal(input);
        }

        /// <summary>
        /// GomOrderFlowCustomValue
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomOrderFlowCustomValue GomOrderFlowCustomValue()
        {
            return _indicator.GomOrderFlowCustomValue(Input);
        }

        /// <summary>
        /// GomOrderFlowCustomValue
        /// </summary>
        /// <returns></returns>
        public Indicator.GomOrderFlowCustomValue GomOrderFlowCustomValue(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomOrderFlowCustomValue(input);
        }

        /// <summary>
        /// OrderFlowProLevels
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomOrderFlowProLevels GomOrderFlowProLevels(Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProLevels(Input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, imbalanceMinLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        /// <summary>
        /// OrderFlowProLevels
        /// </summary>
        /// <returns></returns>
        public Indicator.GomOrderFlowProLevels GomOrderFlowProLevels(Data.IDataSeries input, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minTickSize, bool resetNakedOnSessionStart, bool sRCancelOnNewSession, Gom.OrderFlow.SRZoneEndConditionType sRExit, int sRHiLoThreshold, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomOrderFlowProLevels(input, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceMaxLosingSideVolume, imbalanceMinLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minTickSize, resetNakedOnSessionStart, sRCancelOnNewSession, sRExit, sRHiLoThreshold, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        /// <summary>
        /// GomOrderFlowValues
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomOrderFlowProValues GomOrderFlowProValues(bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            return _indicator.GomOrderFlowProValues(Input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }

        /// <summary>
        /// GomOrderFlowValues
        /// </summary>
        /// <returns></returns>
        public Indicator.GomOrderFlowProValues GomOrderFlowProValues(Data.IDataSeries input, bool decliningTotVolSmallerThanOppositeSideTotVol, Gom.DeltaLib.DeltaCalcType deltaMode, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion1Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion1Direction, double imbalanceCriterion1Value, Gom.OrderFlow.ImbalanceComparisonType imbalanceCriterion2Comparison, Gom.OrderFlow.ImbalanceDirectionType imbalanceCriterion2Direction, double imbalanceCriterion2Value, bool imbalanceInDecliningZoneAuthorized, int imbalanceMaxLosingSideVolume, int imbalanceMinLosingSideVolume, int imbalanceMinWinningSideVolume, int maxTickSize, int minNumOfDecliningLevels, int minSizeOfCounterSideImbalance, int minTickSize, bool reinitSession, Gom.OrderFlow.ReversalPocPositionType reversalPocPosition, int sRMinTotalVolume, int sRNbLevels, int ticksPerPriceLevel)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomOrderFlowProValues(input, decliningTotVolSmallerThanOppositeSideTotVol, deltaMode, imbalanceCriterion1Comparison, imbalanceCriterion1Direction, imbalanceCriterion1Value, imbalanceCriterion2Comparison, imbalanceCriterion2Direction, imbalanceCriterion2Value, imbalanceInDecliningZoneAuthorized, imbalanceMaxLosingSideVolume, imbalanceMinLosingSideVolume, imbalanceMinWinningSideVolume, maxTickSize, minNumOfDecliningLevels, minSizeOfCounterSideImbalance, minTickSize, reinitSession, reversalPocPosition, sRMinTotalVolume, sRNbLevels, ticksPerPriceLevel);
        }
    }
}
#endregion
